diff --git a/CONFIG.fail b/CONFIG.fail
new file mode 100644
index 000000000..f46e679c4
--- /dev/null
+++ b/CONFIG.fail
@@ -0,0 +1,315 @@
+ [2024/10/28 17:18:38.567]     ############################################
+ [2024/10/28 17:18:38.567]     #  RUN PARAMETERS: V3
+ [2024/10/28 17:18:38.567]     ############################################
+ [2024/10/28 17:18:38.567]     assert.read_timestamp=0
+ [2024/10/28 17:18:38.567]     background_compact=0
+ [2024/10/28 17:18:38.567]     background_compact.free_space_target=90
+ [2024/10/28 17:18:38.567]     backup=1
+ [2024/10/28 17:18:38.567]     backup.incremental=log
+ [2024/10/28 17:18:38.567]     backup.incr_granularity=16254
+ [2024/10/28 17:18:38.567]     block_cache=0
+ [2024/10/28 17:18:38.567]     block_cache.cache_on_checkpoint=0
+ [2024/10/28 17:18:38.567]     block_cache.cache_on_writes=0
+ [2024/10/28 17:18:38.567]     block_cache.size=40
+ [2024/10/28 17:18:38.567]     buffer_alignment=0
+ [2024/10/28 17:18:38.567]     cache=2016
+ [2024/10/28 17:18:38.567]     cache.evict_max=0
+ [2024/10/28 17:18:38.567]     cache.eviction_dirty_target=0
+ [2024/10/28 17:18:38.567]     cache.eviction_dirty_trigger=0
+ [2024/10/28 17:18:38.567]     cache.minimum=20
+ [2024/10/28 17:18:38.567]     cache.maximum=6338
+ [2024/10/28 17:18:38.567]     checkpoint=wiredtiger
+ [2024/10/28 17:18:38.567]     checkpoint.log_size=187
+ [2024/10/28 17:18:38.567]     checkpoint.wait=98
+ [2024/10/28 17:18:38.567]     chunk_cache=0
+ [2024/10/28 17:18:38.567]     chunk_cache.capacity=1533
+ [2024/10/28 17:18:38.567]     chunk_cache.chunk_size=1
+ [2024/10/28 17:18:38.567]     chunk_cache.storage_path=off
+ [2024/10/28 17:18:38.567]     chunk_cache.type=off
+ [2024/10/28 17:18:38.567]     compact.free_space_target=15
+ [2024/10/28 17:18:38.567]     debug.background_compact=0
+ [2024/10/28 17:18:38.567]     debug.checkpoint_retention=7
+ [2024/10/28 17:18:38.567]     debug.cursor_reposition=1
+ [2024/10/28 17:18:38.567]     debug.eviction=0
+ [2024/10/28 17:18:38.567]     debug.log_retention=2
+ [2024/10/28 17:18:38.567]     debug.realloc_exact=0
+ [2024/10/28 17:18:38.567]     debug.realloc_malloc=0
+ [2024/10/28 17:18:38.567]     debug.slow_checkpoint=0
+ [2024/10/28 17:18:38.568]     debug.table_logging=0
+ [2024/10/28 17:18:38.568]     debug.update_restore_evict=0
+ [2024/10/28 17:18:38.568]     disk.data_extend=0
+ [2024/10/28 17:18:38.568]     disk.direct_io=0
+ [2024/10/28 17:18:38.568]     disk.encryption=none
+ [2024/10/28 17:18:38.568]     disk.mmap=0
+ [2024/10/28 17:18:38.568]     disk.mmap_all=0
+ [2024/10/28 17:18:38.568]     file_manager.close_handle_minimum=18
+ [2024/10/28 17:18:38.568]     file_manager.close_idle_time=19
+ [2024/10/28 17:18:38.568]     file_manager.close_scan_interval=3
+ [2024/10/28 17:18:38.568]     format.abort=0
+ [2024/10/28 17:18:38.568]     format.independent_thread_rng=0
+ [2024/10/28 17:18:38.568]     format.major_timeout=0
+ [2024/10/28 17:18:38.568]     import=0
+ [2024/10/28 17:18:38.568]     logging=0
+ [2024/10/28 17:18:38.568]     logging.compression=none
+ [2024/10/28 17:18:38.568]     logging.file_max=222770
+ [2024/10/28 17:18:38.568]     logging.prealloc=1
+ [2024/10/28 17:18:38.568]     logging.remove=0
+ [2024/10/28 17:18:38.568]     ops.alter=0
+ [2024/10/28 17:18:38.568]     ops.compaction=0
+ [2024/10/28 17:18:38.568]     ops.hs_cursor=0
+ [2024/10/28 17:18:38.568]     ops.bound_cursor=0
+ [2024/10/28 17:18:38.568]     ops.prepare=0
+ [2024/10/28 17:18:38.568]     ops.random_cursor=0
+ [2024/10/28 17:18:38.568]     ops.salvage=0
+ [2024/10/28 17:18:38.568]     ops.throttle=0
+ [2024/10/28 17:18:38.568]     ops.throttle.sleep_us=995348
+ [2024/10/28 17:18:38.568]     ops.verify=1
+ [2024/10/28 17:18:38.568]     prefetch=0
+ [2024/10/28 17:18:38.568]     quiet=1
+ [2024/10/28 17:18:38.568]     random.data_seed=9674722
+ [2024/10/28 17:18:38.568]     random.extra_seed=12595531
+ [2024/10/28 17:18:38.568]     runs.in_memory=0
+ [2024/10/28 17:18:38.568]     runs.ops=0
+ [2024/10/28 17:18:38.568]     runs.predictable_replay=0
+ [2024/10/28 17:18:38.568]     runs.rows=4200000
+ [2024/10/28 17:18:38.568]     runs.tables=7
+ [2024/10/28 17:18:38.568]     runs.threads=28
+ [2024/10/28 17:18:38.568]     runs.timer=6
+ [2024/10/28 17:18:38.568]     runs.verify_failure_dump=0
+ [2024/10/28 17:18:38.568]     statistics.mode=fast
+ [2024/10/28 17:18:38.568]     statistics_log.sources=off
+ [2024/10/28 17:18:38.568]     stress.aggressive_stash_free=0
+ [2024/10/28 17:18:38.568]     stress.aggressive_sweep=0
+ [2024/10/28 17:18:38.568]     stress.checkpoint=0
+ [2024/10/28 17:18:38.568]     stress.checkpoint_evict_page=0
+ [2024/10/28 17:18:38.568]     stress.checkpoint_prepare=0
+ [2024/10/28 17:18:38.568]     stress.compact_slow=0
+ [2024/10/28 17:18:38.568]     stress.evict_reposition=0
+ [2024/10/28 17:18:38.568]     stress.failpoint_eviction_split=0
+ [2024/10/28 17:18:38.568]     stress.failpoint_hs_delete_key_from_ts=1
+ [2024/10/28 17:18:38.568]     stress.hs_checkpoint_delay=0
+ [2024/10/28 17:18:38.568]     stress.hs_search=0
+ [2024/10/28 17:18:38.568]     stress.hs_sweep=0
+ [2024/10/28 17:18:38.568]     stress.prefetch_delay=0
+ [2024/10/28 17:18:38.568]     stress.prepare_resolution_1=0
+ [2024/10/28 17:18:38.568]     stress.sleep_before_read_overflow_onpage=0
+ [2024/10/28 17:18:38.568]     stress.split_1=0
+ [2024/10/28 17:18:38.568]     stress.split_2=0
+ [2024/10/28 17:18:38.568]     stress.split_3=0
+ [2024/10/28 17:18:38.568]     stress.split_4=0
+ [2024/10/28 17:18:38.568]     stress.split_5=0
+ [2024/10/28 17:18:38.568]     stress.split_6=0
+ [2024/10/28 17:18:38.568]     stress.split_7=0
+ [2024/10/28 17:18:38.568]     stress.split_8=0
+ [2024/10/28 17:18:38.568]     tiered_storage.flush_frequency=0
+ [2024/10/28 17:18:38.568]     tiered_storage.storage_source=off
+ [2024/10/28 17:18:38.568]     transaction.implicit=0
+ [2024/10/28 17:18:38.568]     transaction.operation_timeout_ms=2000
+ [2024/10/28 17:18:38.568]     transaction.timestamps=1
+ [2024/10/28 17:18:38.568]     wiredtiger.config=off
+ [2024/10/28 17:18:38.568]     wiredtiger.rwlock=1
+ [2024/10/28 17:18:38.568]     wiredtiger.leak_memory=0
+ [2024/10/28 17:18:38.568]     ############################################
+ [2024/10/28 17:18:38.568]     #  TABLE PARAMETERS: table 1
+ [2024/10/28 17:18:38.568]     ############################################
+ [2024/10/28 17:18:38.568]     table1.btree.compression=zstd
+ [2024/10/28 17:18:38.568]     table1.btree.dictionary=0
+ [2024/10/28 17:18:38.568]     table1.btree.internal_key_truncation=1
+ [2024/10/28 17:18:38.568]     table1.btree.internal_page_max=15
+ [2024/10/28 17:18:38.568]     table1.btree.key_max=22
+ [2024/10/28 17:18:38.568]     table1.btree.key_min=22
+ [2024/10/28 17:18:38.568]     table1.btree.leaf_page_max=12
+ [2024/10/28 17:18:38.569]     table1.btree.memory_page_max=1
+ [2024/10/28 17:18:38.569]     table1.btree.prefix_len=0
+ [2024/10/28 17:18:38.569]     table1.btree.prefix_compression=1
+ [2024/10/28 17:18:38.569]     table1.btree.prefix_compression_min=8
+ [2024/10/28 17:18:38.569]     table1.btree.reverse=0
+ [2024/10/28 17:18:38.569]     table1.btree.split_pct=65
+ [2024/10/28 17:18:38.569]     table1.btree.value_max=509
+ [2024/10/28 17:18:38.569]     table1.btree.value_min=0
+ [2024/10/28 17:18:38.569]     table1.disk.checksum=off
+ [2024/10/28 17:18:38.569]     table1.disk.firstfit=0
+ [2024/10/28 17:18:38.569]     table1.ops.pareto=0
+ [2024/10/28 17:18:38.569]     table1.ops.pareto.skew=83
+ [2024/10/28 17:18:38.569]     table1.ops.pct.delete=0
+ [2024/10/28 17:18:38.569]     table1.ops.pct.insert=62
+ [2024/10/28 17:18:38.569]     table1.ops.pct.modify=0
+ [2024/10/28 17:18:38.569]     table1.ops.pct.read=2
+ [2024/10/28 17:18:38.569]     table1.ops.pct.write=36
+ [2024/10/28 17:18:38.569]     table1.ops.truncate=1
+ [2024/10/28 17:18:38.569]     table1.runs.mirror=1
+ [2024/10/28 17:18:38.569]     table1.runs.source=table
+ [2024/10/28 17:18:38.569]     table1.runs.type=row-store
+ [2024/10/28 17:18:38.569]     ############################################
+ [2024/10/28 17:18:38.569]     #  TABLE PARAMETERS: table 2
+ [2024/10/28 17:18:38.569]     ############################################
+ [2024/10/28 17:18:38.569]     table2.btree.compression=lz4
+ [2024/10/28 17:18:38.569]     table2.btree.dictionary=0
+ [2024/10/28 17:18:38.569]     table2.btree.internal_key_truncation=1
+ [2024/10/28 17:18:38.569]     table2.btree.internal_page_max=9
+ [2024/10/28 17:18:38.569]     table2.btree.key_max=80
+ [2024/10/28 17:18:38.569]     table2.btree.key_min=29
+ [2024/10/28 17:18:38.569]     table2.btree.leaf_page_max=9
+ [2024/10/28 17:18:38.569]     table2.btree.memory_page_max=9
+ [2024/10/28 17:18:38.569]     table2.btree.prefix_len=0
+ [2024/10/28 17:18:38.569]     table2.btree.prefix_compression=0
+ [2024/10/28 17:18:38.569]     table2.btree.prefix_compression_min=7
+ [2024/10/28 17:18:38.569]     table2.btree.reverse=0
+ [2024/10/28 17:18:38.569]     table2.btree.split_pct=67
+ [2024/10/28 17:18:38.569]     table2.btree.value_max=3518
+ [2024/10/28 17:18:38.569]     table2.btree.value_min=18
+ [2024/10/28 17:18:38.569]     table2.disk.checksum=on
+ [2024/10/28 17:18:38.569]     table2.disk.firstfit=1
+ [2024/10/28 17:18:38.569]     table2.ops.pareto=0
+ [2024/10/28 17:18:38.569]     table2.ops.pareto.skew=54
+ [2024/10/28 17:18:38.569]     table2.ops.pct.delete=9
+ [2024/10/28 17:18:38.569]     table2.ops.pct.insert=49
+ [2024/10/28 17:18:38.569]     table2.ops.pct.modify=8
+ [2024/10/28 17:18:38.569]     table2.ops.pct.read=4
+ [2024/10/28 17:18:38.569]     table2.ops.pct.write=30
+ [2024/10/28 17:18:38.569]     table2.ops.truncate=1
+ [2024/10/28 17:18:38.569]     table2.runs.mirror=1
+ [2024/10/28 17:18:38.569]     table2.runs.source=table
+ [2024/10/28 17:18:38.569]     table2.runs.type=row-store
+ [2024/10/28 17:18:38.569]     ############################################
+ [2024/10/28 17:18:38.569]     #  TABLE PARAMETERS: table 3
+ [2024/10/28 17:18:38.569]     ############################################
+ [2024/10/28 17:18:38.569]     table3.btree.compression=zstd
+ [2024/10/28 17:18:38.569]     table3.btree.dictionary=0
+ [2024/10/28 17:18:38.569]     table3.btree.internal_key_truncation=1
+ [2024/10/28 17:18:38.569]     table3.btree.internal_page_max=9
+ [2024/10/28 17:18:38.569]     table3.btree.key_max=66
+ [2024/10/28 17:18:38.569]     table3.btree.key_min=31
+ [2024/10/28 17:18:38.569]     table3.btree.leaf_page_max=15
+ [2024/10/28 17:18:38.569]     table3.btree.memory_page_max=7
+ [2024/10/28 17:18:38.569]     table3.btree.prefix_len=0
+ [2024/10/28 17:18:38.569]     table3.btree.prefix_compression=1
+ [2024/10/28 17:18:38.569]     table3.btree.prefix_compression_min=1
+ [2024/10/28 17:18:38.569]     table3.btree.reverse=0
+ [2024/10/28 17:18:38.569]     table3.btree.split_pct=62
+ [2024/10/28 17:18:38.569]     table3.btree.value_max=3288
+ [2024/10/28 17:18:38.569]     table3.btree.value_min=8
+ [2024/10/28 17:18:38.569]     table3.disk.checksum=on
+ [2024/10/28 17:18:38.569]     table3.disk.firstfit=0
+ [2024/10/28 17:18:38.569]     table3.ops.pareto=0
+ [2024/10/28 17:18:38.569]     table3.ops.pareto.skew=66
+ [2024/10/28 17:18:38.569]     table3.ops.pct.delete=5
+ [2024/10/28 17:18:38.570]     table3.ops.pct.insert=50
+ [2024/10/28 17:18:38.570]     table3.ops.pct.modify=9
+ [2024/10/28 17:18:38.570]     table3.ops.pct.read=35
+ [2024/10/28 17:18:38.570]     table3.ops.pct.write=1
+ [2024/10/28 17:18:38.570]     table3.ops.truncate=1
+ [2024/10/28 17:18:38.570]     table3.runs.mirror=1
+ [2024/10/28 17:18:38.570]     table3.runs.source=table
+ [2024/10/28 17:18:38.570]     table3.runs.type=row-store
+ [2024/10/28 17:18:38.570]     ############################################
+ [2024/10/28 17:18:38.570]     #  TABLE PARAMETERS: table 4
+ [2024/10/28 17:18:38.570]     ############################################
+ [2024/10/28 17:18:38.570]     table4.btree.compression=lz4
+ [2024/10/28 17:18:38.570]     table4.btree.dictionary=0
+ [2024/10/28 17:18:38.570]     table4.btree.internal_key_truncation=1
+ [2024/10/28 17:18:38.570]     table4.btree.internal_page_max=9
+ [2024/10/28 17:18:38.570]     table4.btree.key_max=70
+ [2024/10/28 17:18:38.570]     table4.btree.key_min=30
+ [2024/10/28 17:18:38.570]     table4.btree.leaf_page_max=14
+ [2024/10/28 17:18:38.570]     table4.btree.memory_page_max=10
+ [2024/10/28 17:18:38.570]     table4.btree.prefix_len=0
+ [2024/10/28 17:18:38.570]     table4.btree.prefix_compression=1
+ [2024/10/28 17:18:38.570]     table4.btree.prefix_compression_min=1
+ [2024/10/28 17:18:38.570]     table4.btree.reverse=0
+ [2024/10/28 17:18:38.570]     table4.btree.split_pct=70
+ [2024/10/28 17:18:38.570]     table4.btree.value_max=3074
+ [2024/10/28 17:18:38.570]     table4.btree.value_min=5
+ [2024/10/28 17:18:38.570]     table4.disk.checksum=on
+ [2024/10/28 17:18:38.570]     table4.disk.firstfit=1
+ [2024/10/28 17:18:38.570]     table4.ops.pareto=1
+ [2024/10/28 17:18:38.570]     table4.ops.pareto.skew=47
+ [2024/10/28 17:18:38.570]     table4.ops.pct.delete=70
+ [2024/10/28 17:18:38.570]     table4.ops.pct.insert=5
+ [2024/10/28 17:18:38.570]     table4.ops.pct.modify=2
+ [2024/10/28 17:18:38.570]     table4.ops.pct.read=2
+ [2024/10/28 17:18:38.570]     table4.ops.pct.write=21
+ [2024/10/28 17:18:38.570]     table4.ops.truncate=1
+ [2024/10/28 17:18:38.570]     table4.runs.mirror=1
+ [2024/10/28 17:18:38.570]     table4.runs.source=file
+ [2024/10/28 17:18:38.570]     table4.runs.type=row-store
+ [2024/10/28 17:18:38.570]     ############################################
+ [2024/10/28 17:18:38.570]     #  TABLE PARAMETERS: table 5
+ [2024/10/28 17:18:38.570]     ############################################
+ [2024/10/28 17:18:38.570]     table5.btree.bitcnt=3
+ [2024/10/28 17:18:38.570]     table5.btree.compression=snappy
+ [2024/10/28 17:18:38.570]     table5.btree.internal_key_truncation=1
+ [2024/10/28 17:18:38.570]     table5.btree.internal_page_max=16
+ [2024/10/28 17:18:38.570]     table5.btree.leaf_page_max=12
+ [2024/10/28 17:18:38.570]     table5.btree.memory_page_max=2
+ [2024/10/28 17:18:38.570]     table5.btree.split_pct=58
+ [2024/10/28 17:18:38.570]     table5.disk.checksum=on
+ [2024/10/28 17:18:38.570]     table5.disk.firstfit=0
+ [2024/10/28 17:18:38.570]     table5.ops.pareto=0
+ [2024/10/28 17:18:38.570]     table5.ops.pareto.skew=7
+ [2024/10/28 17:18:38.570]     table5.ops.pct.delete=0
+ [2024/10/28 17:18:38.570]     table5.ops.pct.insert=0
+ [2024/10/28 17:18:38.570]     table5.ops.pct.modify=0
+ [2024/10/28 17:18:38.570]     table5.ops.pct.read=0
+ [2024/10/28 17:18:38.570]     table5.ops.pct.write=100
+ [2024/10/28 17:18:38.570]     table5.ops.truncate=1
+ [2024/10/28 17:18:38.570]     table5.runs.mirror=1
+ [2024/10/28 17:18:38.570]     table5.runs.source=table
+ [2024/10/28 17:18:38.570]     table5.runs.type=fixed-length column-store
+ [2024/10/28 17:18:38.570]     ############################################
+ [2024/10/28 17:18:38.570]     #  TABLE PARAMETERS: table 6
+ [2024/10/28 17:18:38.570]     ############################################
+ [2024/10/28 17:18:38.570]     table6.btree.compression=zstd
+ [2024/10/28 17:18:38.570]     table6.btree.dictionary=0
+ [2024/10/28 17:18:38.570]     table6.btree.internal_key_truncation=1
+ [2024/10/28 17:18:38.570]     table6.btree.internal_page_max=15
+ [2024/10/28 17:18:38.570]     table6.btree.leaf_page_max=12
+ [2024/10/28 17:18:38.570]     table6.btree.memory_page_max=2
+ [2024/10/28 17:18:38.570]     table6.btree.repeat_data_pct=71
+ [2024/10/28 17:18:38.570]     table6.btree.split_pct=57
+ [2024/10/28 17:18:38.570]     table6.btree.value_max=2392
+ [2024/10/28 17:18:38.570]     table6.btree.value_min=13
+ [2024/10/28 17:18:38.570]     table6.disk.checksum=on
+ [2024/10/28 17:18:38.570]     table6.disk.firstfit=0
+ [2024/10/28 17:18:38.570]     table6.ops.pareto=1
+ [2024/10/28 17:18:38.570]     table6.ops.pareto.skew=100
+ [2024/10/28 17:18:38.570]     table6.ops.pct.delete=29
+ [2024/10/28 17:18:38.570]     table6.ops.pct.insert=6
+ [2024/10/28 17:18:38.570]     table6.ops.pct.modify=23
+ [2024/10/28 17:18:38.570]     table6.ops.pct.read=38
+ [2024/10/28 17:18:38.570]     table6.ops.pct.write=4
+ [2024/10/28 17:18:38.570]     table6.ops.truncate=1
+ [2024/10/28 17:18:38.570]     table6.runs.mirror=1
+ [2024/10/28 17:18:38.570]     table6.runs.source=table
+ [2024/10/28 17:18:38.571]     table6.runs.type=variable-length column-store
+ [2024/10/28 17:18:38.571]     ############################################
+ [2024/10/28 17:18:38.571]     #  TABLE PARAMETERS: table 7
+ [2024/10/28 17:18:38.571]     ############################################
+ [2024/10/28 17:18:38.571]     table7.btree.compression=zstd
+ [2024/10/28 17:18:38.571]     table7.btree.dictionary=0
+ [2024/10/28 17:18:38.571]     table7.btree.internal_key_truncation=1
+ [2024/10/28 17:18:38.571]     table7.btree.internal_page_max=16
+ [2024/10/28 17:18:38.571]     table7.btree.key_max=39
+ [2024/10/28 17:18:38.571]     table7.btree.key_min=28
+ [2024/10/28 17:18:38.571]     table7.btree.leaf_page_max=10
+ [2024/10/28 17:18:38.571]     table7.btree.memory_page_max=5
+ [2024/10/28 17:18:38.571]     table7.btree.prefix_len=0
+ [2024/10/28 17:18:38.571]     table7.btree.prefix_compression=0
+ [2024/10/28 17:18:38.571]     table7.btree.prefix_compression_min=8
+ [2024/10/28 17:18:38.571]     table7.btree.reverse=0
+ [2024/10/28 17:18:38.571]     table7.btree.split_pct=50
+ [2024/10/28 17:18:38.571]     table7.btree.value_max=1098
+ [2024/10/28 17:18:38.571]     table7.btree.value_min=20
+ [2024/10/28 17:18:38.571]     table7.disk.checksum=on
+ [2024/10/28 17:18:38.571]     table7.disk.firstfit=0
+ [2024/10/28 17:18:38.571]     table7.ops.pareto=0
+ [2024/10/28 17:18:38.571]     table7.ops.pareto.skew=58
+ [2024/10/28 17:18:38.571]     table7.ops.pct.delete=3
+ [2024/10/28 17:18:38.571]     table7.ops.pct.insert=0
+ [2024/10/28 17:18:38.571]     table7.ops.pct.modify=3
+ [2024/10/28 17:18:38.571]     table7.ops.pct.read=89
+ [2024/10/28 17:18:38.571]     table7.ops.pct.write=5
+ [2024/10/28 17:18:38.571]     table7.ops.truncate=1
+ [2024/10/28 17:18:38.571]     table7.runs.mirror=1
+ [2024/10/28 17:18:38.571]     table7.runs.source=table
+ [2024/10/28 17:18:38.571]     table7.runs.type=row-store
diff --git a/test/evergreen.yml b/test/evergreen.yml
index 487178c56..ac8e5cb7d 100644
--- a/test/evergreen.yml
+++ b/test/evergreen.yml
@@ -3629,7 +3629,7 @@ tasks:
           times: 1        # Number of times to run the loop
 
   - name: skiplist-stress-test
-    tags: ["stress-test-1", "stress-test-zseries-1"]
+    tags: ["stress-test-1", "stress-test-zseries"]
     exec_timeout_secs: 3600 # 1 hour
     commands:
       - func: "get project"
@@ -3662,7 +3662,7 @@ tasks:
             ${python_binary|python3} chunkcache_simple.py
 
   - name: split-stress-test
-    tags: ["stress-test-1", "stress-test-ppc-1", "stress-test-zseries-1"]
+    tags: ["stress-test-1", "stress-test-ppc-1", "stress-test-zseries"]
     # Set 5 hours timeout (60 * 60 * 5)
     exec_timeout_secs: 18000
     commands:
@@ -3755,7 +3755,7 @@ tasks:
       - func: "code coverage publish report"
 
   - name: format-stress-zseries-test
-    tags: ["stress-test-zseries-1"]
+    tags: ["stress-test-zseries"]
     # Set 2.5 hours timeout (60 * 60 * 2.5)
     exec_timeout_secs: 9000
     commands:
@@ -3768,6 +3768,20 @@ tasks:
           #run for 2 hours ( 2 * 60 = 120 minutes), use default config
           format_test_script_args: -e "SEGFAULT_SIGNALS=all" -b "catchsegv ./t" -t 120
 
+  - name: format-stress-zseries-test-repro
+    tags: ["stress-test-zseries"]
+    # Set 2.5 hours timeout (60 * 60 * 2.5)
+    exec_timeout_secs: 9000
+    commands:
+      - func: "get project"
+      - func: "compile wiredtiger"
+        vars:
+          <<: *configure_flags_with_builtins
+      - func: "format test script"
+        vars:
+          #run for 2 hours ( 2 * 60 = 120 minutes), use default config
+          format_test_script_args: -e "SEGFAULT_SIGNALS=all" -b "catchsegv ./t" -t 120 -- -c ../../../CONFIG.fail
+
   - name: format-stress-ppc-test
     tags: ["stress-test-ppc-1"]
     # Set 2.5 hours timeout (60 * 60 * 2.5)
@@ -3828,13 +3842,13 @@ tasks:
     tags: ["stress-test-sanitizer"]
   - <<: *recovery-stress-test
     name: recovery-stress-test-1
-    tags: ["stress-test-1", "stress-test-zseries-1"]
+    tags: ["stress-test-1", "stress-test-zseries"]
   - <<: *recovery-stress-test
     name: recovery-stress-test-2
-    tags: ["stress-test-2", "stress-test-zseries-2"]
+    tags: ["stress-test-2", "stress-test-zseries"]
   - <<: *recovery-stress-test
     name: recovery-stress-test-3
-    tags: ["stress-test-3", "stress-test-zseries-3"]
+    tags: ["stress-test-3", "stress-test-zseries"]
 
   - name: format-stress-test-no-barrier
     tags: ["stress-test-no-barrier"]
@@ -5694,7 +5708,7 @@ buildvariants:
 - name: big-endian
   display_name: "~ Big-endian (s390x/zSeries)"
   run_on:
-  - rhel80-zseries-build
+  - rhel8-zseries-small
   batchtime: 4320 # 3 days
   expansions:
     ENABLE_TCMALLOC: 0
@@ -5731,7 +5745,7 @@ buildvariants:
 - name: rhel8-zseries
   display_name: "~ RHEL8 zSeries"
   run_on:
-  - rhel80-zseries-test
+  - rhel8-zseries-small
   batchtime: 120 # 2 hours
   expansions:
     ENABLE_TCMALLOC: 0
@@ -5741,9 +5755,7 @@ buildvariants:
     - name: compile
     - name: unit-test
     - name: format-smoke-test
-    - name: ".stress-test-zseries-1"
-    - name: ".stress-test-zseries-2"
-    - name: ".stress-test-zseries-3"
+    - name: ".stress-test-zseries"
 
 - name: ubuntu2004-arm64
   display_name: "~ Ubuntu 20.04 ARM64"